package mmtext.images;





public interface IGrayScaleImage extends IImage{

    public static final int COLOR_WHITE = 255;
    
    public static final int COLOR_BLACK = 0;
    
    public void initImage(int color);
    
    public IGrayScaleImage duplicate();
    
    public int getPixel(int x, int y);
    
    public void setPixel(int x, int y, int value);
    
    public int[][] getPixels();
    
    public void setPixels(int matrix[][]);
    
    public IBinaryImage convertBinaryImage(int limiar, int background);
    
    public int getPixelMax();
    
    public int getPixelMin();
    
    public int numPixels();
    
    public IGrayScaleImage invert();
    
    public int[] getHistogram();
    
    public void resize(int x, int y);
    
    public void resizeCenter(int x, int y);
    
    public void setPixel(int i, int level); 
    
    public int getPixel(int i);
    
    public int getSize();
    
    public int countPixels(int color);
    
    public void replaceColor(int colorOld, int colorNew);
    
    public BoundBox getBoundBox(int x1, int y1, int x2, int y2, int fore);
    
    public void printPixels();
   
}
    