package mmtext.images.operators;

import mmtext.images.GrayScaleImage;
import mmtext.images.IBinaryImage;
import mmtext.images.IGrayScaleImage;
import mmtext.images.IImage;
import mmtext.images.utils.ImageUtils;
import mmtext.images.utils.Matrix;
import mmtext.images.utils.Resampling;

public class Transformation {

	public static IImage[] homography(IBinaryImage imgIn, IGrayScaleImage imgIn2, int x, int y, double alpha){
		IGrayScaleImage imgAux = new GrayScaleImage(imgIn.getWidth(), imgIn.getHeight());
		IGrayScaleImage imgAux2 = new GrayScaleImage(imgIn.getWidth(), imgIn.getHeight());
		for(int i=0;i<imgAux.getSize();i++){
			imgAux.setPixel(i, 256);
			imgAux2.setPixel(i, 256);
		}
		
		double[][] h = new double[3][3];
		double[][] res = new double[1][3];
		alpha = -Math.toRadians(alpha);
		
		h[0][0] = -1*(x - y)*(x - alpha*y + alpha -1);
		h[0][1] = -y*(alpha - 1)*(x - alpha*y + alpha -1);
		h[0][2] = -1*(alpha - 1)*(x - y);
		h[1][0] = alpha*(x - y)*(x - alpha*y + alpha -1);
		h[1][1] = x*(alpha - 1)*(x - alpha*y + alpha -1);
		h[1][2] = alpha*(alpha - 1)*(x - y);
		h[2][0] = 0;
		h[2][1] = 0;
		h[2][2] = (alpha - 1)*(x - y)*(x - alpha*y);
		
		int[] bounds = ImageUtils.imageBounds(imgIn);
		
		int[][] topXL = new int[1][3];
		topXL[0][0] = bounds[0];
		topXL[0][1] = bounds[1];
		topXL[0][2] = 1;
		double[][] topL = Matrix.multiplication(topXL, h);
		topL[0][0] = topL[0][0]/topL[0][2];
		topL[0][1] = topL[0][1]/topL[0][2];
		
		int[][] topXR = new int[1][3];
		topXR[0][0] = bounds[2];
		topXR[0][1] = bounds[3];
		topXR[0][2] = 1;
		double[][] bottomR = Matrix.multiplication(topXR, h);
		bottomR[0][0] = bottomR[0][0]/bottomR[0][2];
		bottomR[0][1] = bottomR[0][1]/bottomR[0][2];
		
		double ratioW = (bottomR[0][0] - topL[0][0])/(bounds[2]-bounds[0]);
		double ratioH = (bottomR[0][1] - topL[0][1])/(bounds[3]-bounds[1]);
		
		int difW = (int)Math.round(bounds[2] - bottomR[0][0]/ratioW);
		int difH = (int)Math.round(bounds[3] - bottomR[0][1]/ratioH);
		
		for(int i=0;i<imgAux.getWidth();i++)
			for(int j=0;j<imgAux.getHeight();j++){
				int[][] temp = new int[1][3];
				temp[0][0] = i;
				temp[0][1] = j;
				temp[0][2] = 1;
				res = Matrix.multiplication(temp, h);
				int xOut = (int)(res[0][0]/(res[0][2]*ratioW)+difW);
				int yOut = (int)(res[0][1]/(res[0][2]*ratioH)+difH);
					
				if(ImageUtils.isIndexInImage(imgAux, xOut, yOut)){
					imgAux.setPixel(xOut, yOut, imgIn.getPixel(i, j));
					imgAux2.setPixel(xOut, yOut, imgIn2.getPixel(i, j));
				}
			}
		
		return new IImage[]{Resampling.nearestNeighborInterpolationB(imgAux), Resampling.nearestNeighborInterpolationG(imgAux2)};
	}
}
