package mmtext.images.operators.uao;
/**
 * O atributo em questao e' a altura de um Node (i.e., yMax-yMin+1, onde yMax e' o maior valor
 * de y de um pixel pertencente ao Node atual e yMin e' o analogo)
 * 
 * @author alexandremorimitsu
 *
 */
public class Attribute {
	private int yMin;
	private int yMax;
	private int xMin;
	private int xMax;
	private int area;
	private int type;
	
	public Attribute(int type){
		this.type = type;
	}

	public int getyMin() {
		return yMin;
	}
	public void setyMin(int yMin) {
		this.yMin = yMin;
	}
	public int getyMax() {
		return yMax;
	}
	public void setyMax(int yMax) {
		this.yMax = yMax;
	}
	
	public double compute(){
		if(type == 1) //altura
			return getyMax() - getyMin() + 1;
		else if(type == 2) //largura
			return getxMax() - getxMin() + 1;
		else if(type == 3) //area
			return getArea();
		else{ //teste
			double d = (double)area/((getxMax() - getxMin() + 1)*(getyMax() - getyMin() + 1));
			if(d > 1.0)
				System.out.println(d);
			return d;
		}
	}

	public int getxMin() {
		return xMin;
	}

	public void setxMin(int xMin) {
		this.xMin = xMin;
	}

	public int getxMax() {
		return xMax;
	}

	public void setxMax(int xMax) {
		this.xMax = xMax;
	}

	public int getArea() {
		return area;
	}

	public void setArea(int area) {
		this.area = area;
	}

	public int getType() {
		return type;
	}

	public void setType(int type) {
		this.type = type;
	}
	
	
}
