package mmtext.images.operators.uao;
import java.util.ArrayList;
import java.util.Stack;

import mmtext.images.utils.Pixel;

public class PriorityStack {
	private ArrayList<Stack<Pixel>> s;
	private int maximumLevel = -1;
	
	public PriorityStack(){
		s = new ArrayList<Stack<Pixel>>(256);
		for(int i=0;i<256;i++){
			s.add(new Stack<Pixel>());
		}
	}
	
	public int getMaximumLevel(){
		return maximumLevel;
	}
	
	public void push(Pixel p, int level){
		s.get(level).add(p);
		if(level > maximumLevel)
			maximumLevel = level;
	}
	
	public void calcMaximumLevel(){
		int i;
		for (i = maximumLevel -1; i >= 0 && s.get(i).isEmpty();i--);
		maximumLevel = i;
	}
	
	public Pixel pop(){
		Pixel p;
		p = s.get(getMaximumLevel()).pop();
		if(s.get(getMaximumLevel()).isEmpty())
			calcMaximumLevel();
		return p;
	}
	
	public ArrayList<Stack<Pixel>> getS() {
		return s;
	}

	public void setS(ArrayList<Stack<Pixel>> s) {
		this.s = s;
	}

}