package mmtext.images.utils;

import java.awt.Point;


public class Pixel {

    private int nivelDeCinza;
    private int x;
    private int y;
    private boolean linhaDeWatershed;
    private int rotuloBacia;
    private boolean permanente;

	public Pixel(int x, int y) {
		this.x = x;
		this.y = y;
	}
    
    public Pixel(int nivelDeCinza, int x, int y) {
        this.nivelDeCinza = nivelDeCinza;
        this.x = x;
        this.y = y;
        linhaDeWatershed = false;
        rotuloBacia = 0;
        permanente = false;
    }
    
    public void setNivelDeCinza(int nivel){
    	nivelDeCinza = nivel;
    }

    public boolean isLinhaDeWatershed() {
        return linhaDeWatershed;
    }

    public void setLinhaDeWatershed(boolean linhaDeWatershed) {
        this.linhaDeWatershed = linhaDeWatershed;
    }

    public int getNivelDeCinza() {
        return nivelDeCinza;
    }

    public boolean isPermanente() {
        return permanente;
    }

    public void setPermanente(boolean permanente) {
        this.permanente = permanente;
    }

    public int getRotuloBacia() {
        return rotuloBacia;
    }

    public void setRotuloBacia(int rotuloBacia) {
        this.rotuloBacia = rotuloBacia;
    }

    public int getX() {
        return x;
    }

    public int getY() {
        return y;
    }
    
    
    public int hashCode(){
    	return new Point(x, y).hashCode();
    }
    
    public boolean equals(Object o){
    	if(o instanceof Pixel){
    		Pixel p = (Pixel) o;
    		if(p.getX() == this.getX() && p.getY() == this.getY())
    			return true;
    	}
    	
    	return false;	
    	
    }
    
    public Pixel rotatePixel(Pixel pIn, double angle, int w, int h)
    {
    	int x, y;
    	double rad = Math.toRadians(angle);
    	x = (int)Math.round(Math.cos(rad)*(pIn.getX()-w)-Math.sin(rad)*(pIn.getY()-h)) + w;
    	y = (int)Math.round(Math.sin(rad)*(pIn.getX()-w)+Math.cos(rad)*(pIn.getY()-h)) + h;
    	y = pIn.getY() + pIn.getY() - y;
    	
    	return new Pixel(x,y);
    }

}
